<?php

namespace App\DataTables;

use App\Models\Cucina;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Storage;
use Illuminate\Support\Str;

class CucinaDataTableEditor extends DataTablesEditor
{
  protected $model = Cucina::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'nome.required' => 'Il nome è richiesto',
    'descrizione.required' => 'La descrizione è richiesta',
    'immagine.required' => 'L\'immagine è richiesta',
    'is_attiva.required' => 'Indicare una delle due opzioni',
    'coperto_come_piatto.boolean' => 'Indicare una delle due opzioni',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    return [
      'nome'  => 'required',
      'descrizione' => 'nullable',
      'immagine' => 'nullable|image|mimes:jpeg,png,jpg,gif,svg|max:2048',
      // 'is_attiva' => 'boolean',
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    return [
      'nome'  => 'required',
      'descrizione' => 'nullable',
      'immagine' => 'nullable|image|mimes:jpeg,png,jpg,gif,svg|max:2048',
      // 'is_attiva' => 'boolean',
    ];
  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attiva'] = isset($data['is_attiva']) ? true : false;
    
    $data['info']['coperto_come_piatto'] = filter_var($data['coperto_come_piatto'] ?? false, FILTER_VALIDATE_BOOLEAN);
    $data['info']['colore'] = $data['colore'];

    // $data['info']['coperto_come_piatto'] = isset($data['coperto_come_piatto']) ? true : false;
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    // dd($data['ruolo']);
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attiva'] = isset($data['is_attiva']) ? true : false;
    $data['info']['colore'] = $data['colore'];
    $data['info']['coperto_come_piatto'] = filter_var($data['coperto_come_piatto'] ?? false, FILTER_VALIDATE_BOOLEAN);

    return $data;
  }
  public function messages(): array
  {
    return $this->messages;
  }

}
